/**
   * @license
   * author: Richard Shephard
   * stencil-tailwind-plugin.js v1.4.1
   * Released under the MIT license.
   */
import n from"path";import t from"fs-extra";import e from"chalk";import i from"p-queue";import r,{ScriptTarget as o,SyntaxKind as s}from"typescript";import c from"postcss";import a from"autoprefixer";import u from"tailwindcss/lib/processTailwindFeatures";import l from"tailwindcss/lib/public/resolve-config";import f from"postcss-load-config";import d from"cssnano";import p from"postcss-combine-duplicated-selectors";import m from"postcss-discard-comments";let g,w=!1;function h(...n){w&&console.log(e.bold.blue("[DBG]"),...n)}function b(...n){console.log(e.bold.bgRedBright("[ERR]"),e.bold.red(...n))}const y={DEFAULT:{enableDebug:!1,tailwindCssPath:void 0,tailwindCssContents:"@tailwind base;@tailwind utilities;@tailwind components;",tailwindConf:{content:[],theme:{extend:{}},plugins:[]},stripComments:!1,minify:!0,useAutoPrefixer:!0}};function x(){return null!=g?g:y.DEFAULT}function C(i){const r=t.readFileSync(n.resolve(i)).toString();return 0===r.length?(function(...n){console.log(e.bold.yellowBright("[WRN]"),...n)}("No css found when reading Tailwind configuration css - path",i),null):r}function S(n){return r.createSourceFile("placeholder.ts",n,o.Latest)}function T(n){return function(t,e){const i=n[e];if(i&&t.kind===i.nodeKind){if(i.has){if(!t.modifiers)return!1;let n=!1;for(let e=0;e<t.modifiers.length;++e)if(t.modifiers[e].kind===i.has){n=!0;break}if(!n)return!1}return i.name?t.name&&t.name.escapedText===i.name:!i.initializerKind||t.initializer&&t.initializer.kind===i.initializerKind}return!1}}function E(n,t){const e=T(t);let i=0;return function n(o){return e(o,i)&&(i++,i===t.length)?o:r.forEachChild(o,n)}(n)}function O(n,{name:t,modifier:e,initializer:i}={}){return{nodeKind:n,name:t,has:e,initializerKind:i}}function v(n,t){let e=0;const i=T(n);return function(o){function c(a){return h("[Typescript]","Visiting "+s[a.kind]),i(a,e)?(e++,e===n.length?t(a):(h("[Typescript]","Moving to next tree level",e,"looking for",s[n[e].nodeKind]),a=r.visitEachChild(a,c,o))):a}return function(n){return r.visitNode(n,c)}}}function F(n,t){return n.findIndex((n=>"function"==typeof n&&n.name===t||"object"==typeof n&&null!==n&&(n.postcssPlugin===t||n.name===t)))}function P(){return m({removeAll:!0})}function j(){return[p(),d()]}async function A(){const n=x(),t=await async function(n){const t={plugins:[]};let e="";if("object"==typeof n&&!Array.isArray(n)&&null!==n&&Array.isArray(n.plugins))return n.plugins;("string"==typeof n||n instanceof String)&&(e=n);try{return(await f(t,e)).plugins}catch(t){if("MODULE_NOT_FOUND"===t.code)throw new Error(`'stencil-tailwind-plugin' is not able to resolve modules required from configuration files. Make sure it is installed\nError: ${t.message}`);h("[TW]","No postcss configuration file found in:",n)}return[]}(n.postcss),e=F(t,"tailwindcss"),i=-1!==F(t,"autoprefixer");return{before:-1===e?[]:t.slice(0,e),after:-1===e?t:t.slice(e+1),hasAutoPrefixer:i}}async function D(n,t,e){const i=x(),r=function(n,t){var e;let i=t;return Array.isArray(g.tailwindConf.corePlugins)?Object.assign(Object.assign({},g.tailwindConf),{content:n,corePlugins:[]}):(t&&g.tailwindConf.corePlugins&&(i=null===(e=g.tailwindConf.corePlugins.preflight)||void 0===e||e),Object.assign(Object.assign({},g.tailwindConf),{content:n,corePlugins:Object.assign(Object.assign({},g.tailwindConf.corePlugins),{preflight:i})}))}([n],e),{before:o,after:s,hasAutoPrefixer:c}=await A(),f=[...o,function(n,t){const e=()=>({postcssPlugin:"tailwindcss",Once(e,{result:i}){u((({createContext:e})=>()=>e(l(n),[t])))(e,i)}});return e.postcss=!0,e}(r,{content:t,extension:"tsx"}),...s];return i.useAutoPrefixer&&!c&&f.push(a()),i.minify&&f.push(...j()),i.stripComments&&f.push(P()),f}async function R(n,t,e,i){const r=x(),o=`${r.tailwindCssContents} ${null!=i?i:""}`,s=await D(t,e,n),a=function(n,t){return t?n:n.replace(/\n/g,"").replace(/'/g,'"').replace(/`/g,"\\`").replace(/\t/g," ")}((await c(s).process(o,{from:t})).css,r.minify);return h("[TW]","Tailwind styles:",a),a}function k(n,t,e){return R(!1,n,t,e)}function z(n,t,e){return R(!0,n,t,e)}const L=[];function V(n){return n.replace(/\\/g,"/")}function $(t){const e=n.parse(t);return V(n.join(e.dir,e.name))}function K(n,t){const e=V(n),i=t.map($),r=function(n){return L.find((t=>t.name===n))}(e);if(void 0===r)return h("[STORE]","Registered",i,"with",e),void L.push(function(n,t){return{imports:t,cssFiles:{},name:n}}(e,i));h("[STORE]","Updated",i,"with",e),r.imports.push(...i)}function N(n,t){const e=V(n);h("[STORE]","Registering css for",e,"against",t);const i=function(n){const t=$(n);return function(e){return-1!==e.imports.indexOf(t)||e.name===n}}(e);L.forEach((n=>{i(n)&&(h("[STORE]","Found cross reference for imported file",n.name,"to store css against"),n.cssFiles[e]={name:e,css:t})}))}function B(n){const t=V(n);h("[STORE]","Looking up import of",t);const e=function(n){const t=$(n);return h("[STORE]","Import spec for matching",t),L.filter((n=>n.imports.includes(t)))}(t).reduce(((n,t)=>(n.css+=Object.entries(t.cssFiles).reduce(((t,[e,i])=>(t+=i.css,n.dependencies.push(i.name),t)),""),n)),{css:"",dependencies:[]});return h("[STORE]","Injecting css",e),e}async function U(t,e,i){const o=[O(s.SourceFile),O(s.FirstStatement),O(s.VariableDeclarationList),O(s.VariableDeclaration),O(s.StringLiteral)],a=B(i).css,u=E(t,o);await(async t=>{const r=t.text,o=await z(i,e,r),s=await async function(t,e,i){const{minify:r,stripComments:o}=x(),s=e+i;if(!r||0===i.length)return s;const a=n.join(".",n.relative(process.cwd(),t)),u=j();return o&&u.push(P()),(await c(u).process(s,{from:a})).css}(i,o,a);t.text=s})(u);return r.createPrinter().printFile(t)}function I(){return[O(s.SourceFile),O(s.VariableStatement),O(s.VariableDeclarationList),O(s.VariableDeclaration,{initializer:s.ClassExpression})]}function M(n,t){const e=I();let i="";const o=function(n,t,e){let i=!1;const o=r.transform(n,[v(t,(function(n){return h("Found Node, calling user processing"),i=!0,e(n)}))]),[s]=o.transformed,c=r.createPrinter();return{found:i,fullText:c.printFile(s)}}(n,e,(n=>{const t=n;return t.name&&t.initializer&&t.initializer.kind===s.ClassExpression&&(i=t.name.escapedText),n}));if(o.found){const n=r.factory.createIdentifier(`'${t}'`);o.fullText=`${o.fullText}${i}.style = ${n.escapedText};\n`}return o}function W(t,e){const i=n.parse(e),o=[];!function(n,t,e){(function n(i){return i.kind===t&&e(i)?i:r.forEachChild(i,n)})(n)}(t,s.ImportDeclaration,(function(t){const e=t.moduleSpecifier,r=n.resolve(i.dir,e.text);return o.push(r),!1})),K(e,o)}function q(n){return!function(n){return void 0!==E(n,[O(s.SourceFile),O(s.VariableStatement,{modifier:s.ExportKeyword}),O(s.VariableDeclarationList),O(s.VariableDeclaration),O(s.ClassExpression),O(s.GetAccessor,{name:"style",modifier:s.StaticKeyword}),O(s.Block),O(s.ReturnStatement)])}(n)&&!function(n){return void 0!==E(n,[O(s.SourceFile),O(s.ExpressionStatement),O(s.BinaryExpression)])}(n)}async function G(n,t){h("[Typescript]","Processing source file:",t);const e=S(n),i=q(e),r=i&&function(n){return void 0!==E(n,I())}(e)?z:k,o=await r(t,n);if(0===o.length)return n;const s=o.replace(/\\/g,"\\\\");if(W(e,t),i){const n=function(n,t){const e=M(n,t);return{text:e.fullText,transformed:e.found}}(e,s);if(n.transformed)return n.text}return N(t,o),n}function _(){h("Starting build")}function H(n){n&&(b("Oh noes! Something went wrong!",n.message),b(n.stack)),h("Build completed")}const J=new i({concurrency:1});async function Q(n,t){return await J.add((async()=>{let e=n;return t.match(/\.s?(a|c)ss/)?e=await async function(n,t){h("[Stylesheets]","Processing source file:",t);const e=S(n);return await U(e,n,t)}(n,t):function(n){return n.match(/\.tsx/)}(t)&&(e=await G(n,t)),{code:e,map:null}}))}async function X(n,t){return await J.add((async()=>{const e=B(t);return{code:""===e.css?n:`${n} ${e.css}`,map:null,dependencies:e.dependencies}}))}const Y=Object.freeze(y);function Z(n){const t=Object.assign({},Y.DEFAULT,n);var e;!function(n){var t;g=Object.assign({},n),g.tailwindCssPath&&(g.tailwindCssContents=null!==(t=C(g.tailwindCssPath))&&void 0!==t?t:g.tailwindCssContents)}(t),e=t.enableDebug,w=e}function nn(n){return Z(n),{name:"tailwind",transform:Q,buildStart:_,buildEnd:H}}function tn(){return{pluginType:"css",name:"tailwind-hmr",transform:X,buildStart:_,buildEnd:H}}export{Y as PluginOpts,nn as default,tn as tailwindHMR};
//# sourceMappingURL=index.esm.js.map
